package com.zhuangzi.bootdemo01.controller;

import com.zhuangzi.bootdemo01.entity.Sorts;
import com.zhuangzi.bootdemo01.repository.SortsRepository;
import com.zhuangzi.bootdemo01.service.SortsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.ArrayList;

@Controller
public class SortsController {
    @Autowired
    @Qualifier("sortsService")
    private SortsService sortsService;
    @Autowired
    private SortsRepository sortsDao;
    @GetMapping(value = "/admin/sorts/add")
    public String add(@RequestParam(defaultValue = "0") Integer parentId, Model model){
        model.addAttribute("selectTrees",sortsService.selectTrees(0,"parentId",parentId));
        return "admin/sorts/add";
    }
    @PostMapping(value = "/admin/sorts/addSave")
    @ResponseBody
    public String addSave(Sorts sorts){
        return sortsService.addSorts(sorts);
    }

    @GetMapping(value = "/admin/sorts/list")
    public String list(Model model){
        ArrayList<Sorts> all = sortsService.getChildren(0,"",null);
        model.addAttribute("all",all);
        return "admin/sorts/list";
    }

    @GetMapping(value = "/admin/sorts/update")
    public String update(@RequestParam(defaultValue = "0") Integer id,Model model){
        Sorts sorts = sortsDao.getOne(id);
        model.addAttribute("sorts",sorts);
        model.addAttribute("selectTrees",sortsService.selectTrees(0,"parentId",sorts.getParentId()));
        return "/admin/sorts/update";
    }

    @PostMapping(value = "/admin/sorts/updateSave")
    @ResponseBody
    public String updateSave(Sorts sorts){
        return sortsService.updateSorts(sorts);
    }

    @GetMapping(value = "/admin/sorts/del")
    @ResponseBody
    public String del(@RequestParam(defaultValue = "0") Integer id){
        return sortsService.deleteAllSortsById(id);
    }
}
