package com.zhuangzi.bootdemo01.repository;

import com.zhuangzi.bootdemo01.entity.Sorts;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import javax.transaction.Transactional;
import java.util.ArrayList;
import java.util.Map;

public interface SortsRepository extends JpaRepository<Sorts,Integer>, JpaSpecificationExecutor<Sorts> {
    @Query(value=" select * from sorts where parentId = ?1 order by orders asc ",nativeQuery=true )
    public ArrayList<Sorts> selectByParentId(Integer id) ;
    @Query(value="select * from sorts where parentId = :#{#sorts.parentId} and sortName = :#{#sorts.sortName}",nativeQuery=true )
    public Sorts selectBySortNameAndParendId(@Param("sorts") Sorts sorts);
    @Query(value = " select * from sorts where parentId = :#{#sorts.parentId} and sortName = :#{#sorts.sortName} " +
            "and id <> :#{#sorts.id}",nativeQuery = true)
    public Sorts selectSortsByParentIdSortName(@Param("sorts") Sorts sorts);
    @Query(value = " update sorts set sortPath = replace(sortPath,:#{#sorts.oldSortPath},:#{#sorts.newSortPath}) where\n" +
            "        sortPath like concat('%',:#{#sorts.oldSortPath},'%') and id <> :#{#sorts.id}",
            nativeQuery = true)
    @Transactional
    @Modifying
    public int updateAllChildSorts(@Param("sorts")Sorts sorts);

    @Query(value = "  update sorts set levels = length(sortPath)- length(replace(sortPath,',','')) - 1 where\n" +
            "        sortPath like concat('%',:#{#sorts.newSortPath},'%') and id <> :#{#sorts.id}",
            nativeQuery = true)
    @Transactional
    @Modifying
    public int updateAllChildSortsLevels(@Param("sorts")Sorts sorts);

    @Query(value = "delete from sorts where sortPath like concat ('%',','+ :id +',','%')",
            nativeQuery = true)
    @Transactional
    @Modifying
    public int deleteAllSortsById(@Param("id") Integer id);
}
